#!/usr/bin/perl -w
use strict;
use Text::Wrap qw(wrap $columns);
$columns = 80;

my $word = undef;
my $descr = undef;
my $indent = "    ";
my $indent2 = "$indent  ";
my $indent3 = "$indent.$indent.$indent";
my %words = ();

while (<>) {
    last if (/^\-\- $/);	# sep
}

while (<>) {
    if (/^:(.*?):\t(.*)$/) {
	die "oj $. $_" if (defined $descr || defined $word);

	$word = $1;
	$descr = $2;
	$_ = $2;
	
	s/\n//g;
	s/\s+$//g;
	s/^\s+$//g;
	s/\s+\;/;/g;
	s/\]\;/]/g;
    
        if (length($_) > 74) {
		warn "to long: $_ -> (\n";
		if (/;  [a-z]\) /) {
		    $_ = wrap($indent, $indent2, $_);
		} else {
		    $_ = wrap($indent, $indent,  $_);
		}
		
		s/;  ([a-z]\))\s*\n/;\n$1/g;
		s/\n([a-z]\))\s+/\n$indent2$1 /g;
		
		warn "$_)\n";
		$descr = "$_\n";
            } else {
		$descr = "$indent$_\n";
	    }	
        }
	
	while (<>) {
	    if (/^\-\- $/) {	# sep
		die "dup $word $." if (defined $words{$word});
		$words{$word} = $descr;
		$descr = undef;
		$word = undef;
		last;
	    }
	    s/\n//g;
	    s/\s+$//g;
	    s/^\s+$//g;
	    s/\s+\;/;/g;
	    s/\]\;/]/g;

if (length($_) > 74) {
    warn "to long: $_ -> (\n";
    if (/;  [a-z]\) /) {
	$_ = wrap($indent, $indent2, $_);
    } else {
	$_ = wrap($indent, $indent,  $_);
    }
    
    s/;  ([a-x]\))\s*\n/;\n$1/g;
    s/\n([a-x]\))\s+/\n$indent2$1 /g;
    
    warn "$_)\n";
    $descr .= "$_\n";
} else {
    $descr .= "$indent$_\n";
}	

}
}

my $n = 0;
foreach my $word (sort keys %words) {
    $n++;
    printf "$word\n$words{$word}\n";
}
    
    
